SIGRETURN(2)

NAME
sigreturn - return from signal

SYNOPSIS

#include <signal.h>
struct sigcontext {
	int	sc_onstack;	/* sigstack state to restore */
	int	sc_mask;	/* signal mask to restore */
	int	sc_cpu_regs[16];	/* ARM cpu registers */
	struct	fp_regs sc_fp_regs;	/* floating point registers */
};
sigreturn(scp);
struct sigcontext *scp;

DESCRIPTION
Sigreturn allows users to atomically unmask, switch stacks, and return from a signal context. The processes signal mask and stack status are restored from the context. The system call does not return; the users stack pointer, frame pointer, argument pointer, and processor status longword are restored from the context. Execution resumes at the specified pc. This system call is used by the trampoline code, and longjmp(3) when returning from a signal to the previously executing program.

NOTES
This system call is not available in 4.2BSD, hence it should not be used if backward compatibility is needed. The format of the “sigcontext” structure varies according to the machine architecture on which the program runs. The above description only applies to the ARM.

RETURN VALUE
If successful, the system call does not return. Otherwise, a value of -1 is returned and errno is set to indicate the error.

ERRORS
Sigreturn will fail and the process context will remain unchanged if one of the following occurs.

[EFAULT]
    Scp points to memory that is not a valid part of the process address space.

[EINVAL]
    The process status longword is invalid or would improperly raise the privilege level of the process.

SEE ALSO
sigvec(2), setjmp(3), aupcs(7), afp(7), __set_sigcontext(3)